﻿using System;
using System.Diagnostics;
using System.ServiceProcess;
using WcfAppServer.Logging;

namespace WcfAppServer
{
    internal static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        private static void Main()
        {
            ServiceBase[] ServicesToRun;
            var tranquilityApplicationServer = new TranquilityApplicationServer();
            ServicesToRun = new ServiceBase[]
                                {
                                    tranquilityApplicationServer
                                };
            try
            {
                ServiceBase.Run(ServicesToRun);
            }
            catch (Exception e)
            {
                LoggingService.Logger.Trace("Program.Main");
                LoggingService.Logger.Error(e);
                tranquilityApplicationServer.ExitCode = 1;
                tranquilityApplicationServer.Stop();
            }
            finally
            {
                tranquilityApplicationServer.Dispose();
            }
        }
    }
}